DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Gauges - Overview

DevExtreme JavaScript Gauge controls help you visualize data and create dashboards. Our library includes three gauge types: radial bar gauges, circular scale gauges, and linear gauges.

This demo displays a simple dashboard with a few highly customized gauges.

Review other demos in this section to explore gauge features such as geometry customization, palettes, tooltips, and custom label display.

Backend API
$(() => { const color = '#f05b41'; const gaugeOptions = { scale: { startValue: 0, endValue: 100, tickInterval: 50, }, valueIndicator: { color, }, value: 20, size: { width: 90, height: 90, }, }; const speedGauge = $('#speed-gauge').dxCircularGauge({ geometry: { startAngle: 225, endAngle: 315, }, scale: { startValue: 20, endValue: 200, tickInterval: 20, minorTickInterval: 10, }, valueIndicator: { indentFromCenter: 55, color, spindleSize: 0, spindleGapSize: 0, }, centerTemplate: (gauge, container) => { const circle = document.createElementNS('http://www.w3.org/2000/svg', 'circle'); const text = document.createElementNS('http://www.w3.org/2000/svg', 'text'); circle.setAttribute('cx', 100); circle.setAttribute('cy', 100); circle.setAttribute('r', 55); circle.setAttribute('stroke-width', 2); circle.setAttribute('stroke', color); circle.setAttribute('fill', 'transparent'); text.setAttribute('text-anchor', 'middle'); text.setAttribute('alignment-baseline', 'middle'); text.setAttribute('x', 100); text.setAttribute('y', 100); text.setAttribute('font-size', 50); text.setAttribute('font-weight', 'lighter'); text.setAttribute('fill', color); text.textContent = gauge.value(); container.appendChild(circle); container.appendChild(text); }, value: 40, size: { width: 260, }, }).dxCircularGauge('instance'); $('#coolant-gauge').dxCircularGauge($.extend(true, {}, gaugeOptions, { geometry: { startAngle: 180, endAngle: 90 }, })); $('#psi-gauge').dxCircularGauge($.extend(true, {}, gaugeOptions, { scale: { startValue: 100, endValue: 0 }, geometry: { startAngle: 90, endAngle: 0 }, })); $('#rpm-gauge').dxCircularGauge($.extend(true, {}, gaugeOptions, { scale: { startValue: 100, endValue: 0 }, geometry: { startAngle: -90, endAngle: -180 }, })); $('#instant-fuel-gauge').dxCircularGauge($.extend(true, {}, gaugeOptions, { geometry: { startAngle: 0, endAngle: -90 }, })); const fuelGauge = $('#fuel-gauge').dxLinearGauge({ scale: { startValue: 0, endValue: 50, tickInterval: 25, minorTickInterval: 12.5, minorTick: { visible: true, }, label: { visible: false, }, }, valueIndicator: { color, size: 8, offset: 7, }, value: 40.4, size: { width: 90, height: 20, }, }).dxLinearGauge('instance'); $('#slider').dxSlider({ min: 0, max: 200, value: 40, width: 155, onValueChanged(e) { const gauges = ['coolant', 'psi', 'rpm', 'instant-fuel']; speedGauge.value(e.value); gauges.forEach((gaugeName) => { $(`#${gaugeName}-gauge`).dxCircularGauge('instance').value(e.value / 2); }); fuelGauge.value(50 - e.value * 0.24); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gauge-demo"> <div id="gauge-container"> <div class="left-section"> <div id="coolant-gauge"></div> <div id="rpm-gauge"></div> </div> <div class="center-section"> <div id="speed-gauge"></div> <div id="fuel-gauge"></div> </div> <div class="right-section"> <div id="psi-gauge"></div> <div id="instant-fuel-gauge"></div> </div> </div> <div id="slider"></div> </div> </div> </body> </html>
#gauge-demo { height: 500px; } #gauge-container { text-align: center; margin: 20px auto; background-image: url('../../../../images/Gauges/mask.png'); background-repeat: no-repeat; width: 786px; height: 500px; } #gauge-container > div { display: inline-block; position: relative; } .left-section { top: -20px; left: -40px; } .center-section { top: 25px; } .right-section { top: -20px; right: -40px; } #fuel-gauge { position: absolute; left: 34%; bottom: 5%; } #slider { position: relative; top: -105px; margin: 0 auto; } #slider .dx-slider-bar { background-color: #fff; } #slider .dx-slider-handle { background-color: #f05b41; width: 16px; height: 16px; margin-top: -8px; margin-right: -8px; border-radius: 50%; border: none; } #slider .dx-slider-handle .dx-inkripple-wave { background: none; } #slider .dx-slider-handle::after { background-color: #f05b41; } #slider .dx-slider-range.dx-slider-range-visible { border-color: #f05b41; background-color: #f05b41; }
NOTE

Use our DevExpress BI Dashboard to embed interactive business intelligence into your next web app.

The Web Dashboard is a data analysis UI component that you can embed into your ASP.NET Core or Angular, React, and Vue applications with .NET backend. Dashboards allow you to display multiple inter-connected data analysis elements such as grids, charts, maps, gauges, and others: all within an automatically-arranged layout.

The set of components allows you to deploy an all-in-one solution and switch between Viewer and Designer modes directly on the web client (includes adaptive layouts for tablet & mobile).

The Web Dashboard is available as a part of a Universal subscription.

Get Started with DevExpress BI Dashboard | Explore Demos

DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Gauges - Overview

DevExtreme React Gauge controls help you visualize data and create dashboards. Our library includes three gauge types: radial bar gauges, circular scale gauges, and linear gauges.

This demo displays a simple dashboard with customized gauges.

Review other demos in this section to explore gauge features such as geometry customization, palettes, tooltips, and custom label display.

Learn more about DevExtreme React components.

Backend API
import React, { useCallback, useState } from 'react'; import CircularGauge, { Geometry, Scale as CircularScale, Size as CircularSize, ValueIndicator as CircularValueIndicator, } from 'devextreme-react/circular-gauge'; import LinearGauge, { Label, MinorTick, Scale as LinearScale, Size as LinearSize, ValueIndicator as LinearValueIndicator, } from 'devextreme-react/linear-gauge'; import Slider from 'devextreme-react/slider'; import Indicator from './Indicator.tsx'; const color = '#f05b41'; function CenterTemplate(gauge) { return ( <svg> <circle cx="100" cy="100" r="55" strokeWidth="2" stroke={color} fill="transparent"></circle> <text textAnchor="middle" alignmentBaseline="middle" y="100" x="100" fontSize="50" fontWeight="lighter" fill={color}>{gauge.value()}</text> </svg> ); } function App() { const [speedValue, setSpeedValue] = useState(40); const handleSpeedChange = useCallback(({ value }) => { setSpeedValue(value); }, [setSpeedValue]); return ( <div id="gauge-demo"> <div id="gauge-container"> <div className="left-section"> <Indicator value={speedValue / 2} inverted={false} startAngle={180} endAngle={90} color={color} /> <Indicator value={speedValue / 2} inverted={true} startAngle={-90} endAngle={-180} color={color} /> </div> &nbsp; <div className="center-section"> <CircularGauge value={speedValue} centerRender={CenterTemplate}> <CircularSize width={260} /> <CircularScale startValue={20} endValue={200} tickInterval={20} minorTickInterval={10} /> <Geometry startAngle={225} endAngle={315} /> <CircularValueIndicator indentFromCenter={55} color={color} spindleSize={0} spindleGapSize={0} /> </CircularGauge> <LinearGauge value={50 - speedValue * 0.24} id="fuel-gauge"> <LinearSize width={90} height={20} /> <LinearScale startValue={0} endValue={50} tickInterval={25} minorTickInterval={12.5} > <MinorTick visible={true} /> <Label visible={false} /> </LinearScale> <LinearValueIndicator size={8} offset={7} color={color} /> </LinearGauge> </div> &nbsp; <div className="right-section"> <Indicator value={speedValue / 2} inverted={true} startAngle={90} endAngle={0} color={color} /> <Indicator value={speedValue / 2} inverted={false} startAngle={0} endAngle={-90} color={color} /> </div> </div> <Slider value={speedValue} onValueChanged={handleSpeedChange} width={155} min={0} max={200} id="slider" /> </div> ); } export default App;
import React, { useCallback, useState } from 'react'; import CircularGauge, { Geometry, Scale as CircularScale, Size as CircularSize, ValueIndicator as CircularValueIndicator, } from 'devextreme-react/circular-gauge'; import LinearGauge, { Label, MinorTick, Scale as LinearScale, Size as LinearSize, ValueIndicator as LinearValueIndicator, } from 'devextreme-react/linear-gauge'; import Slider from 'devextreme-react/slider'; import Indicator from './Indicator.js'; const color = '#f05b41'; function CenterTemplate(gauge) { return ( <svg> <circle cx="100" cy="100" r="55" strokeWidth="2" stroke={color} fill="transparent" ></circle> <text textAnchor="middle" alignmentBaseline="middle" y="100" x="100" fontSize="50" fontWeight="lighter" fill={color} > {gauge.value()} </text> </svg> ); } function App() { const [speedValue, setSpeedValue] = useState(40); const handleSpeedChange = useCallback( ({ value }) => { setSpeedValue(value); }, [setSpeedValue], ); return ( <div id="gauge-demo"> <div id="gauge-container"> <div className="left-section"> <Indicator value={speedValue / 2} inverted={false} startAngle={180} endAngle={90} color={color} /> <Indicator value={speedValue / 2} inverted={true} startAngle={-90} endAngle={-180} color={color} /> </div> &nbsp; <div className="center-section"> <CircularGauge value={speedValue} centerRender={CenterTemplate} > <CircularSize width={260} /> <CircularScale startValue={20} endValue={200} tickInterval={20} minorTickInterval={10} /> <Geometry startAngle={225} endAngle={315} /> <CircularValueIndicator indentFromCenter={55} color={color} spindleSize={0} spindleGapSize={0} /> </CircularGauge> <LinearGauge value={50 - speedValue * 0.24} id="fuel-gauge" > <LinearSize width={90} height={20} /> <LinearScale startValue={0} endValue={50} tickInterval={25} minorTickInterval={12.5} > <MinorTick visible={true} /> <Label visible={false} /> </LinearScale> <LinearValueIndicator size={8} offset={7} color={color} /> </LinearGauge> </div> &nbsp; <div className="right-section"> <Indicator value={speedValue / 2} inverted={true} startAngle={90} endAngle={0} color={color} /> <Indicator value={speedValue / 2} inverted={false} startAngle={0} endAngle={-90} color={color} /> </div> </div> <Slider value={speedValue} onValueChanged={handleSpeedChange} width={155} min={0} max={200} id="slider" /> </div> ); } export default App;
import React from 'react'; import CircularGauge, { Geometry, Scale, Size, ValueIndicator, } from 'devextreme-react/circular-gauge'; interface IndicatorProps { value: number; inverted: boolean; startAngle: number; endAngle: number; color: string; } export default function Indicator(props: IndicatorProps) { return ( <CircularGauge value={props.value}> <Size width={90} height={90} /> <Scale startValue={props.inverted ? 100 : 0} endValue={props.inverted ? 0 : 100} tickInterval={50} /> <Geometry startAngle={props.startAngle} endAngle={props.endAngle} /> <ValueIndicator color={props.color} /> </CircularGauge> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@24.1.6/cjs', 'devextreme-react': 'npm:devextreme-react@24.1.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.11/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.13/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);
import React from 'react'; import CircularGauge, { Geometry, Scale, Size, ValueIndicator, } from 'devextreme-react/circular-gauge'; export default function Indicator(props) { return ( <CircularGauge value={props.value}> <Size width={90} height={90} /> <Scale startValue={props.inverted ? 100 : 0} endValue={props.inverted ? 0 : 100} tickInterval={50} /> <Geometry startAngle={props.startAngle} endAngle={props.endAngle} /> <ValueIndicator color={props.color} /> </CircularGauge> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#gauge-demo { height: 500px; } #gauge-container { text-align: center; margin: 20px auto; background-image: url('../../../../images/Gauges/mask.png'); background-repeat: no-repeat; width: 786px; height: 500px; } #gauge-container > div { display: inline-block; position: relative; } .left-section { top: -20px; left: -40px; } .center-section { top: 25px; } .right-section { top: -20px; right: -40px; } #fuel-gauge { position: absolute; left: 34%; bottom: 5%; } #slider { position: relative; top: -105px; margin: 0 auto; } #slider .dx-slider-bar { background-color: #fff; } #slider .dx-slider-handle { background-color: #f05b41; width: 16px; height: 16px; margin-top: -8px; margin-right: -8px; border-radius: 50%; border: none; } #slider .dx-slider-handle .dx-inkripple-wave { background: none; } #slider .dx-slider-handle::after { background-color: #f05b41; } #slider .dx-slider-range.dx-slider-range-visible { border-color: #f05b41; background-color: #f05b41; }
NOTE

Use our DevExpress BI Dashboard to embed interactive business intelligence into your next web app.

The Web Dashboard is a data analysis UI component that you can embed into your ASP.NET Core or Angular, React, and Vue applications with .NET backend. Dashboards allow you to display multiple inter-connected data analysis elements such as grids, charts, maps, gauges, and others: all within an automatically-arranged layout.

The set of components allows you to deploy an all-in-one solution and switch between Viewer and Designer modes directly on the web client (includes adaptive layouts for tablet & mobile).

The Web Dashboard is available as a part of a Universal subscription.

Get Started with DevExpress BI Dashboard | Explore Demos

Backend API
<template>
<div id="gauge-demo">
<div id="gauge-container">
<div class="left-section">
<GaugeIndicator
:value="speedValue / 2"
:inverted="false"
:start-angle="180"
:end-angle="90"
/>
<GaugeIndicator
:value="speedValue / 2"
:inverted="true"
:start-angle="-90"
:end-angle="-180"
/>
</div>
<div class="center-section">
<DxCircularGauge
:value="speedValue"
center-template="centerTemplate"
>
<DxSize :width="260"/>
<DxValueIndicator
:indent-from-center="55"
:color="color"
:spindle-size="0"
:spindle-gap-size="0"
/>
<DxGeometry
:start-angle="225"
:end-angle="315"
/>
<DxScale
:start-value="20"
:end-value="200"
:tick-interval="20"
:minor-tick-interval="10"
/>
<template #centerTemplate="data">
<svg>
<circle
cx="100"
cy="100"
r="55"
stroke-width="2"
:stroke="color"
fill="transparent"
/>
<text
text-anchor="middle"
x="100"
y="100"
font-size="50"
font-weight="lighter"
alignment-baseline="middle"
:fill="color"
>{{ data.data.value() }}</text>
</svg>
</template>
</DxCircularGauge>
<DxLinearGauge
id="fuel-gauge"
:value="50 - speedValue * 0.24"
>
<DxLinearSize
:width="90"
:height="20"
/>
<DxLinearScale
:start-value="0"
:end-value="50"
:tick-interval="25"
:minor-tick-interval="12.5"
>
<DxMinorTick :visible="true"/>
<DxLabel :visible="false"/>
</DxLinearScale>
<DxLinearValueIndicator
:size="8"
:offset="7"
:color="color"
/>
</DxLinearGauge>
</div>
<div class="right-section">
<GaugeIndicator
:value="speedValue / 2"
:inverted="true"
:start-angle="90"
:end-angle="0"
/>
<GaugeIndicator
:value="speedValue / 2"
:inverted="false"
:start-angle="0"
:end-angle="-90"
/>
</div>
</div>
<DxSlider
id="slider"
v-model:value="speedValue"
:width="155"
:min="0"
:max="200"
/>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSlider from 'devextreme-vue/slider';
import DxCircularGauge, {
DxSize,
DxValueIndicator,
DxGeometry,
DxScale,
} from 'devextreme-vue/circular-gauge';
import DxLinearGauge, {
DxSize as DxLinearSize,
DxValueIndicator as DxLinearValueIndicator,
DxScale as DxLinearScale,
DxMinorTick,
DxLabel,
} from 'devextreme-vue/linear-gauge';
import GaugeIndicator from './GaugeIndicator.vue';
const speedValue = ref(40);
const color = '#f05b41';
</script>
<style src="./styles.css"></style>
<template>
<DxCircularGauge :value="value">
<DxSize
:width="90"
:height="90"
/>
<DxValueIndicator color="#f05b41"/>
<DxGeometry
:start-angle="startAngle"
:end-angle="endAngle"
/>
<DxScale
:start-value="inverted ? 100 : 0"
:end-value="inverted ? 0 : 100"
:tick-interval="50"
/>
</DxCircularGauge>
</template>
<script setup lang="ts">
import DxCircularGauge, {
DxSize,
DxValueIndicator,
DxGeometry,
DxScale,
} from 'devextreme-vue/circular-gauge';
withDefaults(defineProps<{
value?: number
startAngle?: number
endAngle?: number
inverted?: boolean
}>(), {
value: 0,
startAngle: 0,
endAngle: 90,
inverted: true,
});
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
#gauge-demo {
height: 500px;
}
#gauge-container {
text-align: center;
margin: 20px auto;
background-image: url('../../../../images/Gauges/mask.png');
background-repeat: no-repeat;
width: 786px;
height: 500px;
}
#gauge-container > div {
display: inline-block;
position: relative;
}
.left-section {
top: -20px;
left: -44px;
}
.center-section {
top: 25px;
}
.right-section {
top: -20px;
right: -44px;
}
#fuel-gauge {
position: absolute;
left: 34%;
bottom: 5%;
}
#slider {
position: relative;
top: -105px;
margin: 0 auto;
}
#slider .dx-slider-bar {
background-color: #fff;
}
#slider .dx-slider-handle {
background-color: #f05b41;
width: 16px;
height: 16px;
margin-top: -8px;
margin-right: -8px;
border-radius: 50%;
border: none;
}
#slider .dx-slider-handle .dx-inkripple-wave {
background: none;
}
#slider .dx-slider-handle::after {
background-color: #f05b41;
}
#slider .dx-slider-range.dx-slider-range-visible {
border-color: #f05b41;
background-color: #f05b41;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Use our DevExpress BI Dashboard to embed interactive business intelligence into your next web app.
The Web Dashboard is a data analysis UI component that you can embed into your ASP.NET Core or Angular, React, and Vue applications with .NET backend. Dashboards allow you to display multiple inter-connected data analysis elements such as grids, charts, maps, gauges, and others: all within an automatically-arranged layout.
The set of components allows you to deploy an all-in-one solution and switch between Viewer and Designer modes directly on the web client (includes adaptive layouts for tablet & mobile).
The Web Dashboard is available as a part of a Universal subscription.

<div id="gauge-demo">
<div id="gauge-container">
<div class="left-section">
<dx-circular-gauge [value]="speedValue / 2">
<dxo-circular-gauge-size
[width]="90"
[height]="90"
></dxo-circular-gauge-size>
<dxo-circular-gauge-value-indicator [color]="color">
</dxo-circular-gauge-value-indicator>
<dxo-circular-gauge-geometry [startAngle]="180" [endAngle]="90">
</dxo-circular-gauge-geometry>
<dxo-circular-gauge-scale
[startValue]="0"
[endValue]="100"
[tickInterval]="50"
>
</dxo-circular-gauge-scale>
</dx-circular-gauge>
<dx-circular-gauge [value]="speedValue / 2">
<dxo-circular-gauge-size
[width]="90"
[height]="90"
></dxo-circular-gauge-size>
<dxo-circular-gauge-value-indicator
[color]="color"
></dxo-circular-gauge-value-indicator>
<dxo-circular-gauge-geometry [startAngle]="-90" [endAngle]="-180">
</dxo-circular-gauge-geometry>
<dxo-circular-gauge-scale
[startValue]="100"
[endValue]="0"
[tickInterval]="50"
>
</dxo-circular-gauge-scale>
</dx-circular-gauge>
</div>
<div class="center-section">
<dx-circular-gauge
id="speed-gauge"
[value]="speedValue"
centerTemplate="centerTemplate"
>
<dxo-circular-gauge-size [width]="260"></dxo-circular-gauge-size>
<dxo-circular-gauge-value-indicator
[indentFromCenter]="55"
[color]="color"
[spindleSize]="0"
[spindleGapSize]="0"
>
</dxo-circular-gauge-value-indicator>
<dxo-circular-gauge-geometry [startAngle]="225" [endAngle]="315">
</dxo-circular-gauge-geometry>
<dxo-circular-gauge-scale
[startValue]="20"
[endValue]="200"
[tickInterval]="20"
[minorTickInterval]="10"
>
</dxo-circular-gauge-scale>
<svg *dxTemplate="let gauge of 'centerTemplate'">
<circle
cx="100"
cy="100"
r="55"
[attr.stroke]="color"
stroke-width="2"
fill="transparent"
></circle>
<text
text-anchor="middle"
y="100"
x="100"
font-size="50"
font-weight="lighter"
alignment-baseline="middle"
[attr.fill]="color"
>
{{ gauge.value() }}
</text>
</svg>
</dx-circular-gauge>
<dx-linear-gauge id="fuel-gauge" [value]="50 - speedValue * 0.24">
<dxo-linear-gauge-size
[width]="90"
[height]="20"
></dxo-linear-gauge-size>
<dxo-linear-gauge-scale
[startValue]="0"
[endValue]="50"
[tickInterval]="25"
[minorTickInterval]="12.5"
>
<dxo-linear-gauge-minor-tick
[visible]="true"
></dxo-linear-gauge-minor-tick>
<dxo-linear-gauge-label [visible]="false"></dxo-linear-gauge-label>
</dxo-linear-gauge-scale>
<dxo-linear-gauge-value-indicator
[color]="color"
[size]="8"
[offset]="7"
>
</dxo-linear-gauge-value-indicator>
</dx-linear-gauge>
</div>
<div class="right-section">
<dx-circular-gauge [value]="speedValue / 2">
<dxo-circular-gauge-size
[width]="90"
[height]="90"
></dxo-circular-gauge-size>
<dxo-circular-gauge-value-indicator [color]="color">
</dxo-circular-gauge-value-indicator>
<dxo-circular-gauge-geometry [startAngle]="90" [endAngle]="0">
</dxo-circular-gauge-geometry>
<dxo-circular-gauge-scale
[startValue]="100"
[endValue]="0"
[tickInterval]="50"
>
</dxo-circular-gauge-scale>
</dx-circular-gauge>
<dx-circular-gauge [value]="speedValue / 2">
<dxo-circular-gauge-size
[width]="90"
[height]="90"
></dxo-circular-gauge-size>
<dxo-circular-gauge-value-indicator
[color]="color"
></dxo-circular-gauge-value-indicator>
<dxo-circular-gauge-geometry [startAngle]="0" [endAngle]="-90">
</dxo-circular-gauge-geometry>
<dxo-circular-gauge-scale
[startValue]="0"
[endValue]="100"
[tickInterval]="50"
>
</dxo-circular-gauge-scale>
</dx-circular-gauge>
</div>
</div>
<dx-slider
id="slider"
[min]="0"
[max]="200"
[width]="155"
[(value)]="speedValue"
>
</dx-slider>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxCircularGaugeModule, DxLinearGaugeModule, DxSliderModule } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxCircularGaugeModule,
DxLinearGaugeModule,
DxSliderModule,
],
})
export class AppComponent {
speedValue = 40;
color = '#f05b41';
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gauge-demo {
height: 500px;
}
::ng-deep #gauge-container {
text-align: center;
margin: 20px auto;
background-image: url('../../../../images/Gauges/mask.png');
background-repeat: no-repeat;
width: 786px;
height: 500px;
}
::ng-deep #gauge-container > div {
display: inline-block;
position: relative;
}
::ng-deep .left-section {
top: -20px;
left: -40px;
}
::ng-deep .center-section {
top: 25px;
}
::ng-deep .right-section {
top: -20px;
right: -40px;
}
::ng-deep #fuel-gauge {
position: absolute;
left: 34%;
bottom: 5%;
}
::ng-deep #slider {
position: relative;
top: -105px;
margin: 0 auto;
}
::ng-deep #slider .dx-slider-bar {
background-color: #fff;
}
::ng-deep #slider .dx-slider-handle {
background-color: #f05b41;
width: 16px;
height: 16px;
margin-top: -8px;
margin-right: -8px;
border-radius: 50%;
border: none;
}
::ng-deep #slider .dx-slider-handle .dx-inkripple-wave {
background: none;
}
::ng-deep #slider .dx-slider-handle::after {
background-color: #f05b41;
}
::ng-deep #slider .dx-slider-range.dx-slider-range-visible {
border-color: #f05b41;
background-color: #f05b41;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>